---
title: var()
slug: Web/CSS/var()
tags:
  - CSS
  - CSS Custom Properties
  - CSS Function
  - CSS Variables
  - Experimental
  - Function
  - Reference
  - Variables
  - var
  - var()
---
<div>{{CSSRef}}</div>

<p><span class="seoSummary">The <strong><code>var()</code></strong> <a href="/en-US/docs/Web/CSS">CSS</a> <a href="/en-US/docs/Web/CSS/CSS_Functions">function</a> can be used to insert the value of a <a href="/en-US/docs/Web/CSS/--*">custom property</a> (sometimes called a "CSS variable") instead of any part of a value of another property.</span></p>

<div>{{EmbedInteractiveExample("pages/css/var.html")}}</div>

<div class="hidden">The source for this interactive example is stored in a GitHub repository. If you'd like to contribute to the interactive examples project, please clone <a href="https://github.com/mdn/interactive-examples">https://github.com/mdn/interactive-examples</a> and send us a pull request.</div>

<p>The <code>var()</code> function cannot be used in property names, selectors or anything else besides property values. (Doing so usually produces invalid syntax, or else a value whose meaning has no connection to the variable.)</p>

<h2 id="Syntax">Syntax</h2>

<p>The first argument to the function is the name of the custom property to be substituted. An optional second argument to the function serves as a fallback value. If the custom property referenced by the first argument is invalid, the function uses the second value.</p>

<pre class="syntaxbox notranslate">{{csssyntax}}
</pre>

<div class="note">
<p><strong>Note:</strong> The syntax of the fallback, like that of custom properties, allows commas. For example, <code>var(--foo, red, blue)</code> defines a fallback of <code>red, blue</code>; that is, anything between the first comma and the end of the function is considered a fallback value.</p>
</div>

<h3 id="Values">Values</h3>

<dl>
 <dt><code>&lt;custom-property-name&gt;</code></dt>
 <dd>A custom property’s name represented by an identifier that starts with two dashes. Custom properties are solely for use by authors and users; CSS will never give them a meaning beyond what is presented here.</dd>
 <dt><code>&lt;declaration-value&gt;</code></dt>
 <dd>The custom property's fallback value, which is used in case the custom property is invalid in the used context. This value may contain any character except some characters with special meaning like newlines, unmatched closing brackets, i.e. <code>)</code>, <code>]</code>, or <code>}</code>, top-level semicolons, or exclamation marks.</dd>
</dl>

<h2 id="Examples">Examples</h2>

<h3 id="Using_a_custom_property_set_on_root">Using a custom property set on :root</h3>

<pre class="brush: css notranslate">:root {
  --main-bg-color: pink;
}

body {
  background-color: var(--main-bg-color);
}
</pre>

<h3 id="Custom_properties_with_fallbacks_for_use_when_the_property_has_not_been_set">Custom properties with fallbacks for use when the property has not been set</h3>

<pre class="brush: css notranslate">/* Fallback */
/* In the component’s style: */
.component .header {
  color: var(--header-color, blue); /* header-color isn’t set, and so remains blue, the fallback value */
}

.component .text {
  color: var(--text-color, black);
}

/* In the larger application’s style: */
.component {
  --text-color: #080;
}
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('CSS3 Variables', '#using-variables', 'var()')}}</td>
   <td>{{Spec2('CSS3 Variables')}}</td>
   <td>Initial definition</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("css.properties.custom-property.var")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{cssxref("env","env(…)")}} – read‑only environment variables controlled by the user‑agent.</li>
 <li><a href="/en-US/docs/Web/CSS/Using_CSS_variables">Using CSS variables</a></li>
</ul>
